/* (C) 1998,1999 Jakub Jelinek under terms of GPL */
#include <linux/personality.h>
#include <linux/unistd.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/utsname.h>

#ifndef PER_LINUX32
#define PER_LINUX32 8
#endif
#ifndef PER_LINUX_32BIT
#define PER_LINUX_32BIT 0x0800000
#endif

_syscall1(int, personality, long, pers);

int main(int argc, char **argv)
{
	char *p = strrchr(argv[0], '/');
	int quiet = 0;
	
	p = p ? p+1 : argv[0];
	if (argc <= 1) {
		fprintf (stderr, "Usage: %s [-q] program arguments\n", p);
		exit(1);
	}
	if (!strcmp (argv[1], "-q")) {
		quiet = 1;
		argv++;
		argc--;
	}
	if (!strcmp (p, "sparc32")) {
		if (personality(PER_LINUX32) == -1) {
			if (!quiet) perror ("Error setting personality");
			exit(1);
		}
	} else if (!strcmp (p, "sparc64")) {
		struct utsname un;

		if (personality(PER_LINUX_32BIT) == -1 ||
		    personality(PER_LINUX) == -1) {
			if (!quiet) perror ("Error setting personality");
			exit(1);
		}
		uname(&un);
		if (strcmp(un.machine, "sparc64")) {
			if (!quiet) fprintf (stderr, "sparc64: Not a 64bit host\n");
			exit(2);
		}
	} else {
		fprintf (stderr, "sparc32/sparc64 has identity crisis\n");
		exit(3);
	}
	if (quiet && argv[1] == NULL)
		exit(0);
	execvp(argv[1], argv+1);
}
